/* MkRelax, Visual Relax Editor
 *  Copyright (C) 2001-2002 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.ccs2.tool.mkrelax;

import java.io.Serializable;




public class HedgeRefElementModel extends AbstractElementModel implements Serializable {
    static final long serialVersionUID = 8683150608854647147L;

    public HedgeRefElementModel(ModuleModel mm){
	super(mm);
    }

    public HedgeRefElementModel(ModuleModel mm,HedgeRuleElementModel a){
	this(mm);
	setAt(a);
    }


    HedgeRuleElementModel label ;

    public void setAt(HedgeRuleElementModel a) { label = a; }
    public HedgeRuleElementModel getAt() { return label; }

    // ElementOperation stuff

    public boolean acceptOpElement(ElementOperation e) {
	return false;
    }

    public ElementOperation getOpCopy() {
	HedgeRefElementModel ret = ElementUtil.getHedgeRef(getParentModule(),
							   getAt());
	copyTo(ret);
	return ret;
    }

}


